<?php

/*
 * @author Ralph Bolton, July 2004, www.coofercat.com
 * @version 1.0
 * @copyright Copyright &copy; 2004 Ralph Bolton.
 * @license Tiki License
 * @see http://tikiwiki.org for Licensing information.
*/

//this script may only be included - so its better to die if called directly.
if (strpos($_SERVER["SCRIPT_NAME"],basename(__FILE__)) !== false) {
  header("location: index.php");
  exit;
}

/*
 * mixed urlt_get_config_value(object $dbobj, string $key, string $value_type)
 * This function looks up a URLt configuration option of either 'text' or
 * 'int' (the default) types. It only ever returns the first entry in the
 * table that it finds. There is no way to sort this, or handle multiple values.
 *
 * Example: $value=urlt_get_config_value($tikilib->db,'urlt_in_default_mime','text');
 *
 * This function is used by tiki-urlt.php that runs without a full Tiki environment
 * being loaded. Thus, it is necessary to pass a database object to this function.
 * For most users, that will be $tikilib->db.
 *
 * @access private
*/
function urlt_get_config_value($dbobj,$key,$value_type='int')
{
	$value=0;
	if(($rs=$dbobj->SelectLimit("select config_value_$value_type from tiki_urlt_config where config_key=?",1,-1,array($key))) !== false)
	{
	        $value=$rs->fields["config_value_$value_type"];
	        if(!isset($value))
	        {
			if($value_type == 'int')
			{
				return 0;
			}
			else
			{
				return '';
			}
	        }
	}
	return $value;
}
/*
 * int urlt_update_config(string $key, string $valeu, string $value_type)
 * This function updates a URLt configuration option of either 'text' or
 * 'int' (the default) types. If the config key/value does not yet exist,
 * it is added to the table, otherwise it is updated.
 *
 * @access private
*/

function urlt_update_config($key,$value,$value_type='int')
{
        global $tikilib;

        // See if the key is in the DB...
        if(($rs=$tikilib->db->SelectLimit("select configid from tiki_urlt_config where config_key=?",1,-1,array($key))) === false)
        {
		error_log("URLt: Could not do select on tiki_urlt_config: " . $tikilib->db->ErrorMsg());
                return 0;
        }

        // Now check the result of the select and see if we got anything...

        $row=$rs->fields;
        $result=$row['configid'];
        if((isset($result)) && ($result != ""))
        {
                if($tikilib->db->Execute("update tiki_urlt_config set config_key=?, config_value_$value_type=? where configid=?", array($key,$value,$result)) === false)
                {
                        // Still failed! Dunno what's up!
                        error_log("URLt: Couldn't update/add config into tiki_urlt_config (key=$key value=$value): " . $tikilib->db->ErrorMsg());
                        return 0;
                }
        }
        else
        {
                if($tikilib->db->Execute("insert into tiki_urlt_config (config_key,config_value_$value_type) values (?,?)",array($key,$value)) === false)
                {
                        error_log("URLt: Insert failed to tiki_urlt_config with $key = $value : " . $tikilib->db->ErrorMsg());
			return 0;
                }
        }
        return 1;
}

?>
